org.apache.tinkerpop.gremlin.process.computer

## Class GraphComputerTest.VertexProgramM

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.computer.GraphComputerTest.VertexProgramM

- All Implemented Interfaces:
    Cloneable, VertexProgram
  Enclosing class:
    GraphComputerTest

      public static class GraphComputerTest.VertexProgramM
      extends Object
      implements VertexProgram

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.process.computer.VertexProgram

      `VertexProgram.Builder, VertexProgram.Features`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `KNOWS_ONLY`
    `static String` | `ONE_OUT_EDGE_ONLY`
    `static String` | `OUT_EDGES_ONLY`
    `static String` | `PEOPLE_KNOWS_ONLY`
    `static String` | `PEOPLE_KNOWS_WELL_ONLY`
    `static String` | `PEOPLE_ONLY`
    `static String` | `SOFTWARE_ONLY`
    `static String` | `VERTICES_ONLY`

    - ### Fields inherited from interface org.apache.tinkerpop.gremlin.process.computer.VertexProgram

      `VERTEX_PROGRAM`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `VertexProgramM()`
    `VertexProgramM(String state)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `GraphComputerTest.VertexProgramM` | `clone()` When multiple workers on a single machine need VertexProgram instances, it is possible to use clone.
    `void` | `execute(Vertex vertex, Messenger messenger, Memory memory)` This method denotes the main body of the computation and is executed on each vertex in the graph.
    `Set<MessageScope>` | `getMessageScopes(Memory memory)` This method returns all the `MessageScope` possibilities for a particular iteration of the vertex program.
    `GraphComputer.Persist` | `getPreferredPersist()`
    `GraphComputer.ResultGraph` | `getPreferredResultGraph()`
    `void` | `loadState(Graph graph, Configuration configuration)` When it is necessary to load the state of the VertexProgram, this method is called.
    `void` | `setup(Memory memory)` The method is called at the beginning of the computation.
    `void` | `storeState(Configuration configuration)` When it is necessary to store the state of the VertexProgram, this method is called.
    `boolean` | `terminate(Memory memory)` The method is called at the end of each iteration to determine if the computation is complete.

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.computer.VertexProgram

      `createVertexProgram, getFeatures, getMapReducers, getMemoryComputeKeys, getMessageCombiner, getTraverserRequirements, getVertexComputeKeys, workerIterationEnd, workerIterationStart`

- - ### Field Detail

    - #### SOFTWARE_ONLY

          public static final String SOFTWARE_ONLY

      See Also:
        Constant Field Values

    - #### PEOPLE_ONLY

          public static final String PEOPLE_ONLY

      See Also:
        Constant Field Values

    - #### KNOWS_ONLY

          public static final String KNOWS_ONLY

      See Also:
        Constant Field Values

    - #### PEOPLE_KNOWS_ONLY

          public static final String PEOPLE_KNOWS_ONLY

      See Also:
        Constant Field Values

    - #### PEOPLE_KNOWS_WELL_ONLY

          public static final String PEOPLE_KNOWS_WELL_ONLY

      See Also:
        Constant Field Values

    - #### VERTICES_ONLY

          public static final String VERTICES_ONLY

      See Also:
        Constant Field Values

    - #### ONE_OUT_EDGE_ONLY

          public static final String ONE_OUT_EDGE_ONLY

      See Also:
        Constant Field Values

    - #### OUT_EDGES_ONLY

          public static final String OUT_EDGES_ONLY

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### VertexProgramM

          public VertexProgramM()

    - #### VertexProgramM

          public VertexProgramM(String state)

  - ### Method Detail

    - #### setup

          public void setup(Memory memory)

      Description copied from interface: `VertexProgram`
      The method is called at the beginning of the computation. The method is global to the `GraphComputer` and as such, is not called for each vertex. During this stage, the `Memory` should be initialized to to its "start state."
      Specified by:
        `setup` in interface `VertexProgram`
      Parameters:
        `memory` - The global memory of the GraphComputer

    - #### execute

          public void execute(Vertex vertex,
                              Messenger messenger,
                              Memory memory)

      Description copied from interface: `VertexProgram`
      This method denotes the main body of the computation and is executed on each vertex in the graph. This method is logically executed in parallel on all vertices in the graph. When the `Memory` is read, it is according to the aggregated state yielded in the previous iteration. When the `Memory` is written, the data will be aggregated at the end of the iteration for reading in the next iteration.
      Specified by:
        `execute` in interface `VertexProgram`
      Parameters:
        `vertex` - the `Vertex` to execute the `VertexProgram` on
        `messenger` - the messenger that moves data between vertices
        `memory` - the shared state between all vertices in the computation

    - #### terminate

          public boolean terminate(Memory memory)

      Description copied from interface: `VertexProgram`
      The method is called at the end of each iteration to determine if the computation is complete. The method is global to the `GraphComputer` and as such, is not called for each `Vertex`. The `Memory` maintains the aggregated data from the last execute() iteration.
      Specified by:
        `terminate` in interface `VertexProgram`
      Parameters:
        `memory` - The global memory of the `GraphComputer`
      Returns:
        whether or not to halt the computation

    - #### getMessageScopes

          public Set<MessageScope> getMessageScopes(Memory memory)

      Description copied from interface: `VertexProgram`
      This method returns all the `MessageScope` possibilities for a particular iteration of the vertex program. The returned messages scopes are the scopes that will be used to send messages during the stated iteration. It is not a requirement that all stated messages scopes be used, just that it is possible that they be used during the iteration.
      Specified by:
        `getMessageScopes` in interface `VertexProgram`
      Parameters:
        `memory` - an immutable form of the `Memory`
      Returns:
        all possible message scopes during said vertex program iteration

    - #### getPreferredResultGraph

          public GraphComputer.ResultGraph getPreferredResultGraph()

      Specified by:
        `getPreferredResultGraph` in interface `VertexProgram`

    - #### getPreferredPersist

          public GraphComputer.Persist getPreferredPersist()

      Specified by:
        `getPreferredPersist` in interface `VertexProgram`

    - #### clone

          public GraphComputerTest.VertexProgramM clone()

      Description copied from interface: `VertexProgram`
      When multiple workers on a single machine need VertexProgram instances, it is possible to use clone. This will provide a speedier way of generating instances, over the `VertexProgram.storeState(Configuration)` and `VertexProgram.loadState(org.apache.tinkerpop.gremlin.structure.Graph, Configuration)` model. The default implementation simply returns the object as it assumes that the VertexProgram instance is a stateless singleton.
      Specified by:
        `clone` in interface `VertexProgram`
      Overrides:
        `clone` in class `Object`
      Returns:
        A clone of the VertexProgram object

    - #### loadState

          public void loadState(Graph graph,
                                Configuration configuration)

      Description copied from interface: `VertexProgram`
      When it is necessary to load the state of the VertexProgram, this method is called. This is typically required when the VertexProgram needs to be serialized to another machine. Note that what is loaded is simply the instance state, not any processed data.
      Specified by:
        `loadState` in interface `VertexProgram`
      Parameters:
        `graph` - the graph that the VertexProgram will run against
        `configuration` - the configuration to load the state of the VertexProgram from.

    - #### storeState

          public void storeState(Configuration configuration)

      Description copied from interface: `VertexProgram`
      When it is necessary to store the state of the VertexProgram, this method is called. This is typically required when the VertexProgram needs to be serialized to another machine. Note that what is stored is simply the instance/configuration state, not any processed data. The default implementation provided simply stores the VertexProgram class name for reflective reconstruction. It is typically a good idea to VertexProgram.super.storeState().
      Specified by:
        `storeState` in interface `VertexProgram`
      Parameters:
        `configuration` - the configuration to store the state of the VertexProgram in.

Copyright © 2013–2022 Apache Software Foundation. All rights reserved.